<?xml version='1.0'?>

<!--

Copyright 2019 Double Precision, Inc.
See COPYING for distribution information.

Stylesheet for creating class member declarations from appearance/*.xml

-->

<xsl:stylesheet
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

  <xsl:output method="text" />

  <xsl:template match="/appearance">

    <xsl:text>/* Automatically generated by create_headers.xsl */&#10;&#10;// Hide from doxygen, unless this is included from the right place&#10;&#10;#ifndef x_w_</xsl:text>
    <xsl:value-of select="name" />
    <xsl:text>_appearance_inc_h&#10;</xsl:text>
    <xsl:text>#define x_w_</xsl:text>
    <xsl:value-of select="name" />
    <xsl:text>_appearance_inc_h&#10;&#10;#include &lt;x/w/namespace.H&gt;&#10;&#10;LIBCXXW_NAMESPACE_START&#10;&#10;//! Actual properties inherited by \ref </xsl:text>
    <xsl:value-of select="name" />
    <xsl:text>_appearance "INSERT_LIBX_NAMESPACE::w::</xsl:text>
    <xsl:value-of select="name" />
    <xsl:text>_appearance".&#10;&#10;struct LIBCXX_HIDDEN </xsl:text>
    <xsl:value-of select="name" />
    <xsl:text>_appearance_properties {&#10;&#10;&#9;//! Constructor&#10;&#9;</xsl:text>
    <xsl:value-of select="name" />
    <xsl:text>_appearance_properties(</xsl:text>
    <xsl:value-of select="constructor_parameters" />
    <xsl:text>);&#10;&#10;&#9;//! Destructor&#10;&#9;~</xsl:text>
    <xsl:value-of select="name" />
    <xsl:text>_appearance_properties();&#10;&#10;</xsl:text>

    <xsl:for-each select="/appearance/field">

      <xsl:text>/*!</xsl:text>
      <xsl:value-of select="descr" />
      <xsl:text>*/&#10;&#10;        </xsl:text>
      <xsl:choose>
	<xsl:when test="ref">
	  <xsl:text>const_</xsl:text>
	  <xsl:value-of select="ref" />
	  <xsl:text>_appearance</xsl:text>
	</xsl:when>
	<xsl:otherwise>
	  <xsl:if test="optional">
	    <xsl:text>std::optional&lt;</xsl:text>
	  </xsl:if>
	  <xsl:if test="vector">
	    <xsl:text>std::vector&lt;</xsl:text>
	  </xsl:if>
	  <xsl:value-of select="type" />
	  <xsl:if test="optional">
	    <xsl:text>&gt;</xsl:text>
	  </xsl:if>
	  <xsl:if test="vector">
	    <xsl:text>&gt;</xsl:text>
	  </xsl:if>
	</xsl:otherwise>
      </xsl:choose>

      <xsl:text> </xsl:text>
      <xsl:value-of select="name" />
      <xsl:text>;&#10;</xsl:text>
    </xsl:for-each>
    <xsl:text>&#10;};&#10;&#10;LIBCXXW_NAMESPACE_END&#10;&#10;#endif&#10;</xsl:text>
  </xsl:template>
</xsl:stylesheet>
