#include <x/options.H>
#include <x/locale.H>
#include <x/messages.H>

#ifndef N_
#define N_(x) x
#endif

#ifndef NN_
#define NN_(s, p) s, p
#endif

class testcombobox_options {

public:
    x::option::list idm45903513384208; /* Top level option list */

    /* OPTION: editable */

    typedef x::option::bool_value editable_t;

    editable_t editable;

    /* OPTION: layout */

    typedef x::option::bool_value layout_t;

    layout_t layout;

    /* OPTION: callback */

    typedef x::option::bool_value callback_t;

    callback_t callback;

    /* MUTEX: editable, layout */

    x::option::mutex idm45903513348816;

    /* OPTION: book */

    typedef x::option::bool_value book_t;

    book_t book;

    /* CONSTRUCTOR */

    testcombobox_options(const x::messagesptr &msgcat=x::messagesptr())
 : idm45903513384208(x::option::list::create()),
        editable(editable_t::create(false)),
        layout(layout_t::create(false)),
        callback(callback_t::create(false)),
       idm45903513348816(x::option::mutex::create()),
        book(book_t::create(false))
    {
        init(msgcat);
    }

    static std::string getoptmsg(const x::messagesptr &msgcat, const char *str)
    {
        return (!msgcat.null() ? msgcat->get(str):str);
    }

    template<typename int_type>
    static std::string getoptmsg(const x::messagesptr &msgcat, const char *singular, const char *plural, int_type value)
    {
        return (!msgcat.null() ? msgcat->get(singular, plural, value): value == 1 ? singular:plural);
    }

    void init(const x::messagesptr &msgcat)
    {
        idm45903513348816->add(editable).add(layout);

        idm45903513384208->add_option(editable, "e", getoptmsg(msgcat, N_("editable")), 0, getoptmsg(msgcat, N_("Editable combo-box")));

        idm45903513384208->add_option(layout, "l", getoptmsg(msgcat, N_("layout")), 0, getoptmsg(msgcat, N_("Test layout recalculation")));

        idm45903513384208->add_option(callback, "c", getoptmsg(msgcat, N_("callback")), 0, getoptmsg(msgcat, N_("Test callbacks")));

        idm45903513384208->add_option(book, "b", getoptmsg(msgcat, N_("book")), 0, getoptmsg(msgcat, N_("Put the combo-box inside the book layout manager")));

        idm45903513384208->addDefaultOptions();
    }

    /* Construct a parser object */

    x::option::parser getParser(const x::const_locale &localeArg=x::locale::base::environment())
    {
        x::option::parser parser(x::option::parser::create(localeArg));

        parser->setOptions(idm45903513384208);

        return parser;
    }

    /* Parse argc/argv as received by main(), return parser object */

    x::option::parser parse(int argc, char **argv,
                            const x::const_locale &localeArg
                               =x::locale::base::environment())
    {
        x::option::parser parser=getParser(localeArg);

        int err=parser->parseArgv(argc, argv);

        if (err == 0) err=parser->validate();

        if (err)
        {
            if (err == x::option::parser::base::err_builtin)
                exit(0);

            std::cerr << parser->errmessage();
	    std::cerr.flush();
            exit(1);
        }

        return parser;  /* Retrieve parser->args, if desired. */
    }
};
